

DSLIB (1)			DSLIB	  			DSLIB (1)

NAME
	dslib - a data structure manipulation library

SYNOPSIS
	gcc sourcefile -lds -o outfile

DESCRIPTION
	DSLIB contains functions that handle, construct, and destroy various
	data structures, including binary trees, stacks, and doubly linked
	lists.

FUNCTIONS
   for trees:
	make_tree	--	allocates memory for the root of a tree
					and inits all of the values
	make_node	--	allocates memory for a new right or left
					node and inits all of the values
	goto_parent	--	takes a pointer to a certain node and, if
					it isn't root, goes to its parent
	go_left		--	follows the left branch, if it isn't null
	go_right	--	follows the right branch, if it isn't null
	destroy_tree	--	takes a pointer to the root and deallocates
					the entire tree with a recursive
					algorithm

   for doubly linked lists:
	make_list	--	allocates memory for the beginning of a
					list and inits all of the values
	make_elmnt	--	allocates memory for an element at the end
					of a list and inits all of the values
	goto_prev_elmnt --	navigates to the previous element of the list
					if it isn't null
	goto_next_elmnt --	navigates to the next element of the list if
					it isn't null
	destroy_dlink	--	takes a pointer and deallocates all of the
					elements of the list

   for stacks:
	make_stack	--	allocates memory for the struct and actual
					stack and inits al

EXAMPLES
	/* Compiled as follows: gcc sourcefile -lds -o outfile */
	#include <stdio.h>
	#include <stdlib.h>
	#include <dslib.h>

	int main (void)
	{
		stack *s=NULL;
		s=make_stack (50);	//allocates size fifty stack
		push (s, 50);
		push (s, 14);		// push a few values into s
		push (s, 32);

		printf ("The last value pushed was %d.", peek (s));
	}		/*The printf will print 32.*/

REPORTING BUGS
	If you discover any bugs, email me at abram10@aol.com.

COPYRIGHT
	(C) Copyright 2003 by Abram Magner.  There is NO warranty.  This
	software is licensed under the GNU General Public License and you
	may redistribute or modify it under the terms thereof.  For more
	information on the GPL, consult the file entitled COPYING.DOC.
